DeclareModule CkPkcs11
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.l ckNumCerts(obj.i)
  Declare.s ckSharedLibPath(obj.i)
  Declare setCkSharedLibPath(obj.i, value.s)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckCloseSession(obj.i)
  Declare.l ckDiscover(obj.i, onlyTokensPresent.l, json.i)
  Declare.l ckFindAllCerts(obj.i)
  Declare.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i)
  Declare.l ckGetCert(obj.i, index.l, cert.i)
  Declare.l ckInitialize(obj.i)
  Declare.l ckInitPin(obj.i, pin.s)
  Declare.l ckInitToken(obj.i, slotId.l, pin.s, tokenLabel.s)
  Declare.l ckLogin(obj.i, userType.l, pin.s)
  Declare.l ckLogout(obj.i)
  Declare.l ckOpenSession(obj.i, slotId.l, readWrite.l)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckSetPin(obj.i, oldPin.s, newPin.s)
EndDeclareModule

Module CkPkcs11
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklM(obj.i)
  PrototypeC.l cklMlss(obj.i, arg1.l, arg2.s, arg3.s)
  PrototypeC.l cklMli(obj.i, arg1.l, arg2.i)
  PrototypeC.l cklMls(obj.i, arg1.l, arg2.s)
  PrototypeC.l cklMss(obj.i, arg1.s, arg2.s)
  PrototypeC.l cklMll(obj.i, arg1.l, arg2.l)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.l cklMssi(obj.i, arg1.s, arg2.s, arg3.i)
  PrototypeC.i CkPkcs11Create()
  PrototypeC CkPkcs11Dispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.dylib")
    CompilerCase #PB_OS_Linux
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb32-9_5_0.so")
      CompilerElse
        CkPkcs11LibId.i = OpenLibrary(#PB_Any, "libchilkatPb-9_5_0.so")
      CompilerEndIf
  CompilerEndSelect
  Global Pkcs11Create.CkPkcs11Create = GetFunction(CkPkcs11LibId,"CkPkcs11U_CreateW")
  Global Pkcs11Dispose.CkPkcs11Dispose = GetFunction(CkPkcs11LibId,"CkPkcs11U_DisposeW")
  Global Pkcs11DebugLogFilePath.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_debugLogFilePathW")
  Global Pkcs11PSetDebugLogFilePath.cksPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putDebugLogFilePathW")
  Global Pkcs11LastErrorHtml.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorHtmlW")
  Global Pkcs11LastErrorText.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorTextW")
  Global Pkcs11LastErrorXml.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_lastErrorXmlW")
  Global Pkcs11LastMethodSuccess.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getLastMethodSuccessW")
  Global Pkcs11PSetLastMethodSuccess.cklPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putLastMethodSuccessW")
  Global Pkcs11NumCerts.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getNumCertsW")
  Global Pkcs11SharedLibPath.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_sharedLibPathW")
  Global Pkcs11PSetSharedLibPath.cksPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putSharedLibPathW")
  Global Pkcs11VerboseLogging.cklPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_getVerboseLoggingW")
  Global Pkcs11PSetVerboseLogging.cklPropSet = GetFunction(CkPkcs11LibId,"CkPkcs11U_putVerboseLoggingW")
  Global Pkcs11Version.cksPropGet = GetFunction(CkPkcs11LibId,"CkPkcs11U_versionW")
  Global Pkcs11CloseSession.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_CloseSessionW")
  Global Pkcs11Discover.cklMli = GetFunction(CkPkcs11LibId,"CkPkcs11U_DiscoverW")
  Global Pkcs11FindAllCerts.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindAllCertsW")
  Global Pkcs11FindCert.cklMssi = GetFunction(CkPkcs11LibId,"CkPkcs11U_FindCertW")
  Global Pkcs11GetCert.cklMli = GetFunction(CkPkcs11LibId,"CkPkcs11U_GetCertW")
  Global Pkcs11Initialize.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitializeW")
  Global Pkcs11InitPin.cklMs = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitPinW")
  Global Pkcs11InitToken.cklMlss = GetFunction(CkPkcs11LibId,"CkPkcs11U_InitTokenW")
  Global Pkcs11Login.cklMls = GetFunction(CkPkcs11LibId,"CkPkcs11U_LoginW")
  Global Pkcs11Logout.cklM = GetFunction(CkPkcs11LibId,"CkPkcs11U_LogoutW")
  Global Pkcs11OpenSession.cklMll = GetFunction(CkPkcs11LibId,"CkPkcs11U_OpenSessionW")
  Global Pkcs11SaveLastError.cklMs = GetFunction(CkPkcs11LibId,"CkPkcs11U_SaveLastErrorW")
  Global Pkcs11SetPin.cklMss = GetFunction(CkPkcs11LibId,"CkPkcs11U_SetPinW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn Pkcs11Create() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn Pkcs11Dispose(obj) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(Pkcs11DebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn Pkcs11PSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(Pkcs11LastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn Pkcs11LastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn Pkcs11PSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.l ckNumCerts(obj.i) : ProcedureReturn Pkcs11NumCerts(obj) : EndProcedure
  Procedure.s ckSharedLibPath(obj.i) : ProcedureReturn PeekS(Pkcs11SharedLibPath(obj)) : EndProcedure
  Procedure setCkSharedLibPath(obj.i, value.s) : ProcedureReturn Pkcs11PSetSharedLibPath(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn Pkcs11VerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn Pkcs11PSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(Pkcs11Version(obj)) : EndProcedure
  Procedure.l ckCloseSession(obj.i) :  ProcedureReturn Pkcs11CloseSession(obj) :  EndProcedure
  Procedure.l ckDiscover(obj.i, onlyTokensPresent.l, json.i) :  ProcedureReturn Pkcs11Discover(obj, onlyTokensPresent, json) :  EndProcedure
  Procedure.l ckFindAllCerts(obj.i) :  ProcedureReturn Pkcs11FindAllCerts(obj) :  EndProcedure
  Procedure.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i) :  ProcedureReturn Pkcs11FindCert(obj, certPart, partValue, cert) :  EndProcedure
  Procedure.l ckGetCert(obj.i, index.l, cert.i) :  ProcedureReturn Pkcs11GetCert(obj, index, cert) :  EndProcedure
  Procedure.l ckInitialize(obj.i) :  ProcedureReturn Pkcs11Initialize(obj) :  EndProcedure
  Procedure.l ckInitPin(obj.i, pin.s) :  ProcedureReturn Pkcs11InitPin(obj, pin) :  EndProcedure
  Procedure.l ckInitToken(obj.i, slotId.l, pin.s, tokenLabel.s) :  ProcedureReturn Pkcs11InitToken(obj, slotId, pin, tokenLabel) :  EndProcedure
  Procedure.l ckLogin(obj.i, userType.l, pin.s) :  ProcedureReturn Pkcs11Login(obj, userType, pin) :  EndProcedure
  Procedure.l ckLogout(obj.i) :  ProcedureReturn Pkcs11Logout(obj) :  EndProcedure
  Procedure.l ckOpenSession(obj.i, slotId.l, readWrite.l) :  ProcedureReturn Pkcs11OpenSession(obj, slotId, readWrite) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn Pkcs11SaveLastError(obj, path) :  EndProcedure
  Procedure.l ckSetPin(obj.i, oldPin.s, newPin.s) :  ProcedureReturn Pkcs11SetPin(obj, oldPin, newPin) :  EndProcedure
EndModule

