DeclareModule CkScMinidriver
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckAtr(obj.i)
  Declare.s ckCardName(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.l ckMaxContainers(obj.i)
  Declare.s ckRsaPaddingHash(obj.i)
  Declare setCkRsaPaddingHash(obj.i, value.s)
  Declare.s ckRsaPaddingScheme(obj.i)
  Declare setCkRsaPaddingScheme(obj.i, value.s)
  Declare.s ckUncommonOptions(obj.i)
  Declare setCkUncommonOptions(obj.i, value.s)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckAcquireContext(obj.i, readerName.s)
  Declare.l ckCardDeleteFile(obj.i, dirName.s, fileName.s)
  Declare.l ckDeleteCert(obj.i, cert.i, delPrivKey.l)
  Declare.l ckDeleteContext(obj.i)
  Declare.l ckDeleteKeyContainer(obj.i, containerIndex.l)
  Declare.l ckEnumFiles(obj.i, dirName.s, st.i)
  Declare.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i)
  Declare.l ckGenerateKey(obj.i, containerIndex.l, keySpec.s, keyType.s, keySize.l, pinId.s)
  Declare.l ckGetCardProperties(obj.i, json.i)
  Declare.l ckGetCert(obj.i, containerIndex.l, keySpec.s, cert.i)
  Declare.l ckGetContainerKeys(obj.i, containerIndex.l, sigKey.i, kexKey.i)
  Declare.l ckGetCspContainerMap(obj.i, json.i)
  Declare.l ckImportCert(obj.i, cert.i, containerIndex.l, keySpec.s, pinId.s)
  Declare.l ckImportKey(obj.i, containerIndex.l, keySpec.s, privKey.i, pinId.s)
  Declare.l ckListCerts(obj.i, certPart.s, st.i)
  Declare.l ckPinAuthenticate(obj.i, pinId.s, pin.s)
  Declare.l ckPinAuthenticateHex(obj.i, pinId.s, pin.s)
  Declare.l ckPinChange(obj.i, pinId.s, currentPin.s, newPin.s)
  Declare.l ckPinDeauthenticate(obj.i, pinId.s)
  Declare.l ckReadFile(obj.i, dirName.s, fileName.s, bd.i)
  Declare.l ckSaveLastError(obj.i, path.s)
  Declare.l ckSignData(obj.i, containerIndex.l, keySpec.s, hashDataAlg.s, bdData.i, bdSignedData.i)
  Declare.l ckWriteFile(obj.i, dirName.s, fileName.s, bd.i)
EndDeclareModule

Module CkScMinidriver
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklM(obj.i)
  PrototypeC.l cklMil(obj.i, arg1.i, arg2.l)
  PrototypeC.l cklMl(obj.i, arg1.l)
  PrototypeC.l cklMsi(obj.i, arg1.s, arg2.i)
  PrototypeC.l cklMlsis(obj.i, arg1.l, arg2.s, arg3.i, arg4.s)
  PrototypeC.l cklMi(obj.i, arg1.i)
  PrototypeC.l cklMlii(obj.i, arg1.l, arg2.i, arg3.i)
  PrototypeC.l cklMlssls(obj.i, arg1.l, arg2.s, arg3.s, arg4.l, arg5.s)
  PrototypeC.l cklMssi(obj.i, arg1.s, arg2.s, arg3.i)
  PrototypeC.l cklMilss(obj.i, arg1.i, arg2.l, arg3.s, arg4.s)
  PrototypeC.l cklMsss(obj.i, arg1.s, arg2.s, arg3.s)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.l cklMlssii(obj.i, arg1.l, arg2.s, arg3.s, arg4.i, arg5.i)
  PrototypeC.l cklMlsi(obj.i, arg1.l, arg2.s, arg3.i)
  PrototypeC.l cklMss(obj.i, arg1.s, arg2.s)
  PrototypeC.i CkScMinidriverCreate()
  PrototypeC CkScMinidriverDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkScMinidriverLibId.i = OpenLibrary(#PB_Any, "chilkatPb32-9_5_0.dll")
      CompilerElse
        CkScMinidriverLibId.i = OpenLibrary(#PB_Any, "chilkatPb-9_5_0.dll")
      CompilerEndIf
  CompilerEndSelect
  Global ScMinidriverCreate.CkScMinidriverCreate = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_CreateW")
  Global ScMinidriverDispose.CkScMinidriverDispose = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_DisposeW")
  Global ScMinidriverAtr.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_atrW")
  Global ScMinidriverCardName.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_cardNameW")
  Global ScMinidriverDebugLogFilePath.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_debugLogFilePathW")
  Global ScMinidriverPSetDebugLogFilePath.cksPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putDebugLogFilePathW")
  Global ScMinidriverLastErrorHtml.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_lastErrorHtmlW")
  Global ScMinidriverLastErrorText.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_lastErrorTextW")
  Global ScMinidriverLastErrorXml.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_lastErrorXmlW")
  Global ScMinidriverLastMethodSuccess.cklPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_getLastMethodSuccessW")
  Global ScMinidriverPSetLastMethodSuccess.cklPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putLastMethodSuccessW")
  Global ScMinidriverMaxContainers.cklPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_getMaxContainersW")
  Global ScMinidriverRsaPaddingHash.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_rsaPaddingHashW")
  Global ScMinidriverPSetRsaPaddingHash.cksPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putRsaPaddingHashW")
  Global ScMinidriverRsaPaddingScheme.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_rsaPaddingSchemeW")
  Global ScMinidriverPSetRsaPaddingScheme.cksPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putRsaPaddingSchemeW")
  Global ScMinidriverUncommonOptions.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_uncommonOptionsW")
  Global ScMinidriverPSetUncommonOptions.cksPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putUncommonOptionsW")
  Global ScMinidriverVerboseLogging.cklPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_getVerboseLoggingW")
  Global ScMinidriverPSetVerboseLogging.cklPropSet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_putVerboseLoggingW")
  Global ScMinidriverVersion.cksPropGet = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_versionW")
  Global ScMinidriverAcquireContext.cklMs = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_AcquireContextW")
  Global ScMinidriverCardDeleteFile.cklMss = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_CardDeleteFileW")
  Global ScMinidriverDeleteCert.cklMil = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_DeleteCertW")
  Global ScMinidriverDeleteContext.cklM = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_DeleteContextW")
  Global ScMinidriverDeleteKeyContainer.cklMl = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_DeleteKeyContainerW")
  Global ScMinidriverEnumFiles.cklMsi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_EnumFilesW")
  Global ScMinidriverFindCert.cklMssi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_FindCertW")
  Global ScMinidriverGenerateKey.cklMlssls = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_GenerateKeyW")
  Global ScMinidriverGetCardProperties.cklMi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_GetCardPropertiesW")
  Global ScMinidriverGetCert.cklMlsi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_GetCertW")
  Global ScMinidriverGetContainerKeys.cklMlii = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_GetContainerKeysW")
  Global ScMinidriverGetCspContainerMap.cklMi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_GetCspContainerMapW")
  Global ScMinidriverImportCert.cklMilss = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_ImportCertW")
  Global ScMinidriverImportKey.cklMlsis = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_ImportKeyW")
  Global ScMinidriverListCerts.cklMsi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_ListCertsW")
  Global ScMinidriverPinAuthenticate.cklMss = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_PinAuthenticateW")
  Global ScMinidriverPinAuthenticateHex.cklMss = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_PinAuthenticateHexW")
  Global ScMinidriverPinChange.cklMsss = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_PinChangeW")
  Global ScMinidriverPinDeauthenticate.cklMs = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_PinDeauthenticateW")
  Global ScMinidriverReadFile.cklMssi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_ReadFileW")
  Global ScMinidriverSaveLastError.cklMs = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_SaveLastErrorW")
  Global ScMinidriverSignData.cklMlssii = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_SignDataW")
  Global ScMinidriverWriteFile.cklMssi = GetFunction(CkScMinidriverLibId,"CkScMinidriverU_WriteFileW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn ScMinidriverCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn ScMinidriverDispose(obj) : EndProcedure
  Procedure.s ckAtr(obj.i) : ProcedureReturn PeekS(ScMinidriverAtr(obj)) : EndProcedure
  Procedure.s ckCardName(obj.i) : ProcedureReturn PeekS(ScMinidriverCardName(obj)) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(ScMinidriverDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn ScMinidriverPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(ScMinidriverLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(ScMinidriverLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(ScMinidriverLastErrorXml(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn ScMinidriverLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn ScMinidriverPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.l ckMaxContainers(obj.i) : ProcedureReturn ScMinidriverMaxContainers(obj) : EndProcedure
  Procedure.s ckRsaPaddingHash(obj.i) : ProcedureReturn PeekS(ScMinidriverRsaPaddingHash(obj)) : EndProcedure
  Procedure setCkRsaPaddingHash(obj.i, value.s) : ProcedureReturn ScMinidriverPSetRsaPaddingHash(obj,value) : EndProcedure
  Procedure.s ckRsaPaddingScheme(obj.i) : ProcedureReturn PeekS(ScMinidriverRsaPaddingScheme(obj)) : EndProcedure
  Procedure setCkRsaPaddingScheme(obj.i, value.s) : ProcedureReturn ScMinidriverPSetRsaPaddingScheme(obj,value) : EndProcedure
  Procedure.s ckUncommonOptions(obj.i) : ProcedureReturn PeekS(ScMinidriverUncommonOptions(obj)) : EndProcedure
  Procedure setCkUncommonOptions(obj.i, value.s) : ProcedureReturn ScMinidriverPSetUncommonOptions(obj,value) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn ScMinidriverVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn ScMinidriverPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(ScMinidriverVersion(obj)) : EndProcedure
  Procedure.l ckAcquireContext(obj.i, readerName.s) :  ProcedureReturn ScMinidriverAcquireContext(obj, readerName) :  EndProcedure
  Procedure.l ckCardDeleteFile(obj.i, dirName.s, fileName.s) :  ProcedureReturn ScMinidriverCardDeleteFile(obj, dirName, fileName) :  EndProcedure
  Procedure.l ckDeleteCert(obj.i, cert.i, delPrivKey.l) :  ProcedureReturn ScMinidriverDeleteCert(obj, cert, delPrivKey) :  EndProcedure
  Procedure.l ckDeleteContext(obj.i) :  ProcedureReturn ScMinidriverDeleteContext(obj) :  EndProcedure
  Procedure.l ckDeleteKeyContainer(obj.i, containerIndex.l) :  ProcedureReturn ScMinidriverDeleteKeyContainer(obj, containerIndex) :  EndProcedure
  Procedure.l ckEnumFiles(obj.i, dirName.s, st.i) :  ProcedureReturn ScMinidriverEnumFiles(obj, dirName, st) :  EndProcedure
  Procedure.l ckFindCert(obj.i, certPart.s, partValue.s, cert.i) :  ProcedureReturn ScMinidriverFindCert(obj, certPart, partValue, cert) :  EndProcedure
  Procedure.l ckGenerateKey(obj.i, containerIndex.l, keySpec.s, keyType.s, keySize.l, pinId.s) :  ProcedureReturn ScMinidriverGenerateKey(obj, containerIndex, keySpec, keyType, keySize, pinId) :  EndProcedure
  Procedure.l ckGetCardProperties(obj.i, json.i) :  ProcedureReturn ScMinidriverGetCardProperties(obj, json) :  EndProcedure
  Procedure.l ckGetCert(obj.i, containerIndex.l, keySpec.s, cert.i) :  ProcedureReturn ScMinidriverGetCert(obj, containerIndex, keySpec, cert) :  EndProcedure
  Procedure.l ckGetContainerKeys(obj.i, containerIndex.l, sigKey.i, kexKey.i) :  ProcedureReturn ScMinidriverGetContainerKeys(obj, containerIndex, sigKey, kexKey) :  EndProcedure
  Procedure.l ckGetCspContainerMap(obj.i, json.i) :  ProcedureReturn ScMinidriverGetCspContainerMap(obj, json) :  EndProcedure
  Procedure.l ckImportCert(obj.i, cert.i, containerIndex.l, keySpec.s, pinId.s) :  ProcedureReturn ScMinidriverImportCert(obj, cert, containerIndex, keySpec, pinId) :  EndProcedure
  Procedure.l ckImportKey(obj.i, containerIndex.l, keySpec.s, privKey.i, pinId.s) :  ProcedureReturn ScMinidriverImportKey(obj, containerIndex, keySpec, privKey, pinId) :  EndProcedure
  Procedure.l ckListCerts(obj.i, certPart.s, st.i) :  ProcedureReturn ScMinidriverListCerts(obj, certPart, st) :  EndProcedure
  Procedure.l ckPinAuthenticate(obj.i, pinId.s, pin.s) :  ProcedureReturn ScMinidriverPinAuthenticate(obj, pinId, pin) :  EndProcedure
  Procedure.l ckPinAuthenticateHex(obj.i, pinId.s, pin.s) :  ProcedureReturn ScMinidriverPinAuthenticateHex(obj, pinId, pin) :  EndProcedure
  Procedure.l ckPinChange(obj.i, pinId.s, currentPin.s, newPin.s) :  ProcedureReturn ScMinidriverPinChange(obj, pinId, currentPin, newPin) :  EndProcedure
  Procedure.l ckPinDeauthenticate(obj.i, pinId.s) :  ProcedureReturn ScMinidriverPinDeauthenticate(obj, pinId) :  EndProcedure
  Procedure.l ckReadFile(obj.i, dirName.s, fileName.s, bd.i) :  ProcedureReturn ScMinidriverReadFile(obj, dirName, fileName, bd) :  EndProcedure
  Procedure.l ckSaveLastError(obj.i, path.s) :  ProcedureReturn ScMinidriverSaveLastError(obj, path) :  EndProcedure
  Procedure.l ckSignData(obj.i, containerIndex.l, keySpec.s, hashDataAlg.s, bdData.i, bdSignedData.i) :  ProcedureReturn ScMinidriverSignData(obj, containerIndex, keySpec, hashDataAlg, bdData, bdSignedData) :  EndProcedure
  Procedure.l ckWriteFile(obj.i, dirName.s, fileName.s, bd.i) :  ProcedureReturn ScMinidriverWriteFile(obj, dirName, fileName, bd) :  EndProcedure
EndModule

